<template>
  <q-carousel
    v-model="slide"
    transition-prev="scale"
    transition-next="scale"
    swipeable
    animated
    control-color="black"
    navigation
    padding
    arrows
    class="rounded-borders"
  >
    <q-carousel-slide
      v-for="product in  products"
      :key="product.id"
      :name="'style-'+product.id"
      class="row no-wrap flex-center"
    >
      <div class="col-xs-12 col-sm-6 col-6 left-img">
        <q-img style="width: 250px" :src="product.image" />
      </div>

      <div class="col-xs-12 col-sm-6 col-6 q-mt-md">
        <p class="text-subtitle1 text-weight-medium">{{product.name}}</p>
        <div class="q-mb-md ellipsis-2-lines">{{product.description}}</div>
        <q-btn
          @click="addToCart(product)"
          unelevated
          color="primary"
          class="q-mt-sm q-mr-md"
          label="Cumpara acum"
        />
        <q-btn
          @click="openProduct(product.id)"
          outline
          color="primary"
          class="q-mt-sm"
          label="Detalii "
        />
      </div>
    </q-carousel-slide>
  </q-carousel>
</template>

<script>
export default {
  name: "product-carousel",
  data() {
    return {
      slide: "style-1",

      lorem:
        "Lorem ipsum dolor, sit amet consectetur adipisicing elit. Itaque voluptatem totam, architecto cupiditate officia rerum, error dignissimos praesentium libero ab nemo.",
    };
  },
  computed: {
    adminPreferences() {
      return this.$store.getters["adminData/getAdminPreferences"];
    },
    noItems() {
      if (this.adminPreferences.length > 0)
        return parseFloat(
          this.adminPreferences.find(
            (preference) => preference.name === "noItems"
          ).value
        );
      else return 3;
    },
    products() {
      const products = [...this.$store.getters["adminData/getProducts"]]
        .filter(
          (item) =>
            item.preferences.reduce(
              (accumulator, currentValue) =>
                accumulator + currentValue.quantityAvailable,
              0
            ) > 0
        )
        .sort(() => 0.5 - Math.random());
      if (products.length > 0) this.slide = "style-" + products[0].id;
      return products.slice(0, this.noItems);
    },
    shoppingCart() {
      return this.$store.getters["adminData/getShoppingCart"].map((item) => ({
        id: item.preference.id,
        quantity: item.quantity,
      }));
    },
  },
  methods: {
    openProduct(productId) {
      this.$router.push({ name: "product", params: { product: productId } });
    },
    addToCart(product) {
      const selectedProduct = product.preferences.find(
        (item) => item.quantityAvailable > 0
      );
      if (selectedProduct) {
        const updatedShoppingCart = [...this.shoppingCart];
        console.log(updatedShoppingCart);
        const foundItem = this.shoppingCart.find(
          (item) => item.id == selectedProduct.id
        );

        if (foundItem) {
          foundItem.quantity += 1;
        } else {
          updatedShoppingCart.push({
            id: selectedProduct.id,
            quantity: 1,
          });
        }
        this.$axios
          .put("/api/purchases/cart", { items: updatedShoppingCart })
          .then((response) => {
            this.$q.notify({
              message: response.data.message,
              color: "positive",
            });
            this.$store.dispatch("adminData/loadShoppingCart");
          })
          .catch((err) => {
            if (err.response.status == 403) {
              this.$q.notify({
                color: "negative",
                message: "Login first",
                icon: "report_problem",
              });
            } else
              this.$q.notify({
                color: "negative",
                message: err.response.data.message,
                icon: "report_problem",
              });
          });
      } else
        this.$q.notify({
          message: "Nu ai ales culoarea sau marimea",
          color: "negative",
        });
    },
  },
};
</script>

<style lang="scss" scoped>
.left-img {
  display: flex;
  flex-direction: row;
  justify-content: center;
}
</style>
